MapEntry
Date: 2017-07-08

com.google.protobuf

## Class MapEntry<K,V>

- java.lang.Object
- - com.google.protobuf.AbstractMessageLite
  - - com.google.protobuf.AbstractMessage
    - - com.google.protobuf.MapEntry<K,V>

- All Implemented Interfaces:
    Message, MessageLite, MessageLiteOrBuilder, MessageOrBuilder

      public final class MapEntry<K,V>
      extends AbstractMessage

  Implements MapEntry messages. In reflection API, map fields will be treated as repeated message fields and each map entry is accessed as a message. This MapEntry class is used to represent these map entry messages in reflection API. Protobuf internal. Users shouldn't use this class.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `MapEntry.Builder<K,V>` Builder to create `MapEntry` messages.

    - ### Nested classes/interfaces inherited from class com.google.protobuf.AbstractMessage

      `AbstractMessage.BuilderParent`

  - ### Field Summary

    - ### Fields inherited from class com.google.protobuf.AbstractMessage

      `memoizedSize`

    - ### Fields inherited from class com.google.protobuf.AbstractMessageLite

      `memoizedHashCode`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.Map<Descriptors.FieldDescriptor,java.lang.Object>` | `getAllFields()` Returns a collection of all the fields in this message which are set and their corresponding values.
    `MapEntry<K,V>` | `getDefaultInstanceForType()` Get an instance of the type with no fields set.
    `Descriptors.Descriptor` | `getDescriptorForType()` Get the message's type's descriptor.
    `java.lang.Object` | `getField(Descriptors.FieldDescriptor field)` Obtains the value of the given field, or the default value if it is not set.
    `K` | `getKey()`
    `Parser<MapEntry<K,V>>` | `getParserForType()` Gets the parser for a message of the same type as this message.
    `java.lang.Object` | `getRepeatedField(Descriptors.FieldDescriptor field, int index)` Gets an element of a repeated field.
    `int` | `getRepeatedFieldCount(Descriptors.FieldDescriptor field)` Gets the number of elements of a repeated field.
    `int` | `getSerializedSize()` Get the number of bytes required to encode this message.
    `UnknownFieldSet` | `getUnknownFields()` Get the `UnknownFieldSet` for this message.
    `V` | `getValue()`
    `boolean` | `hasField(Descriptors.FieldDescriptor field)` Returns true if the given field is set.
    `boolean` | `isInitialized()` Returns true if all required fields in the message and all embedded messages are set, false otherwise.
    `MapEntry.Builder<K,V>` | `newBuilderForType()` Constructs a new builder for a message of the same type as this message.
    `static <K,V> MapEntry<K,V>` | `newDefaultInstance(Descriptors.Descriptor descriptor, WireFormat.FieldType keyType, K defaultKey, WireFormat.FieldType valueType, V defaultValue)` Create a default MapEntry instance.
    `MapEntry.Builder<K,V>` | `toBuilder()` Constructs a builder initialized with the current message.
    `void` | `writeTo(CodedOutputStream output)` Serializes the message and writes it to `output`.

    - ### Methods inherited from class com.google.protobuf.AbstractMessage

      `equals, findInitializationErrors, getInitializationErrorString, getOneofFieldDescriptor, hashBoolean, hashCode, hashEnum, hashEnumList, hashFields, hashLong, hasOneof, newBuilderForType, toString`

    - ### Methods inherited from class com.google.protobuf.AbstractMessageLite

      `addAll, checkByteStringIsUtf8, toByteArray, toByteString, writeDelimitedTo, writeTo`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.protobuf.MessageLite

      `toByteArray, toByteString, writeDelimitedTo, writeTo`

- - ### Method Detail

    - #### newDefaultInstance

          public static <K,V> MapEntry<K,V> newDefaultInstance(Descriptors.Descriptor descriptor,
                                               WireFormat.FieldType keyType,
                                               K defaultKey,
                                               WireFormat.FieldType valueType,
                                               V defaultValue)

      Create a default MapEntry instance. A default MapEntry instance should be created only once for each map entry message type. Generated code should store the created default instance and use it later to create new MapEntry messages of the same type.

    - #### getKey

          public K getKey()

    - #### getValue

          public V getValue()

    - #### getSerializedSize

          public int getSerializedSize()

      Description copied from interface: `MessageLite`
      Get the number of bytes required to encode this message. The result is only computed on the first call and memoized after that.
      Specified by:
        `getSerializedSize` in interface `MessageLite`
      Overrides:
        `getSerializedSize` in class `AbstractMessage`

    - #### writeTo

          public void writeTo(CodedOutputStream output)
                       throws java.io.IOException

      Description copied from interface: `MessageLite`
      Serializes the message and writes it to `output`. This does not flush or close the stream.
      Specified by:
        `writeTo` in interface `MessageLite`
      Overrides:
        `writeTo` in class `AbstractMessage`
      Throws:
        `java.io.IOException`

    - #### isInitialized

          public boolean isInitialized()

      Description copied from interface: `MessageLiteOrBuilder`
      Returns true if all required fields in the message and all embedded messages are set, false otherwise.

      See also: `MessageOrBuilder.getInitializationErrorString()`

      Specified by:
        `isInitialized` in interface `MessageLiteOrBuilder`
      Overrides:
        `isInitialized` in class `AbstractMessage`

    - #### getParserForType

          public Parser<MapEntry<K,V>> getParserForType()

      Description copied from interface: `MessageLite`
      Gets the parser for a message of the same type as this message.

    - #### newBuilderForType

          public MapEntry.Builder<K,V> newBuilderForType()

      Description copied from interface: `MessageLite`
      Constructs a new builder for a message of the same type as this message.

    - #### toBuilder

          public MapEntry.Builder<K,V> toBuilder()

      Description copied from interface: `MessageLite`
      Constructs a builder initialized with the current message. Use this to derive a new message from the current one.

    - #### getDefaultInstanceForType

          public MapEntry<K,V> getDefaultInstanceForType()

      Description copied from interface: `MessageLiteOrBuilder`
      Get an instance of the type with no fields set. Because no fields are set, all getters for singular fields will return default values and repeated fields will appear empty. This may or may not be a singleton. This differs from the `getDefaultInstance()` method of generated message classes in that this method is an abstract method of the `MessageLite` interface whereas `getDefaultInstance()` is a static method of a specific class. They return the same thing.

    - #### getDescriptorForType

          public Descriptors.Descriptor getDescriptorForType()

      Description copied from interface: `MessageOrBuilder`
      Get the message's type's descriptor. This differs from the `getDescriptor()` method of generated message classes in that this method is an abstract method of the `Message` interface whereas `getDescriptor()` is a static method of a specific class. They return the same thing.

    - #### getAllFields

          public java.util.Map<Descriptors.FieldDescriptor,java.lang.Object> getAllFields()

      Description copied from interface: `MessageOrBuilder`
      Returns a collection of all the fields in this message which are set and their corresponding values. A singular ("required" or "optional") field is set iff hasField() returns true for that field. A "repeated" field is set iff getRepeatedFieldCount() is greater than zero. The values are exactly what would be returned by calling `MessageOrBuilder.getField(Descriptors.FieldDescriptor)` for each field. The map is guaranteed to be a sorted map, so iterating over it will return fields in order by field number.
      If this is for a builder, the returned map may or may not reflect future changes to the builder. Either way, the returned map is itself unmodifiable.

    - #### hasField

          public boolean hasField(Descriptors.FieldDescriptor field)

      Description copied from interface: `MessageOrBuilder`
      Returns true if the given field is set. This is exactly equivalent to calling the generated "has" accessor method corresponding to the field.

    - #### getField

          public java.lang.Object getField(Descriptors.FieldDescriptor field)

      Description copied from interface: `MessageOrBuilder`
      Obtains the value of the given field, or the default value if it is not set. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned. For repeated fields, a java.util.List is returned.

    - #### getRepeatedFieldCount

          public int getRepeatedFieldCount(Descriptors.FieldDescriptor field)

      Description copied from interface: `MessageOrBuilder`
      Gets the number of elements of a repeated field. This is exactly equivalent to calling the generated "Count" accessor method corresponding to the field.

    - #### getRepeatedField

          public java.lang.Object getRepeatedField(Descriptors.FieldDescriptor field,
                                          int index)

      Description copied from interface: `MessageOrBuilder`
      Gets an element of a repeated field. For primitive fields, the boxed primitive value is returned. For enum fields, the EnumValueDescriptor for the value is returned. For embedded message fields, the sub-message is returned.

    - #### getUnknownFields

          public UnknownFieldSet getUnknownFields()

      Description copied from interface: `MessageOrBuilder`
      Get the `UnknownFieldSet` for this message.